<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.dcs.hnyz.mapper.FlowMapper">
    
    <resultMap type="Flow" id="FlowResult">
        <result property="flowId"    column="flow_id"    />
        <result property="flowName"    column="flow_name"    />
        <result property="flowCode" column="flow_code"/>
        <result property="sort"    column="sort"    />
        <result property="status"    column="status"    />
        <result property="delFlag"    column="del_flag"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectFlowVo">
        select flow_id, flow_name, sort, status, del_flag, create_by, create_time, update_by, update_time, remark from flow
    </sql>

    <select id="selectFlowList" parameterType="Flow" resultMap="FlowResult">
        <include refid="selectFlowVo"/>
        <where>  
            <if test="flowName != null  and flowName != ''"> and flow_name like concat('%', #{flowName}, '%')</if>
            <if test="status != null "> and status = #{status}</if>
            <if test="delFlag == null"> and del_flag = '0'</if>
        </where>
        ORDER BY sort
    </select>
    
    <select id="selectFlowByFlowId" parameterType="Long" resultMap="FlowResult">
        <include refid="selectFlowVo"/>
        where flow_id = #{flowId}
    </select>

    <insert id="insertFlow" parameterType="Flow" useGeneratedKeys="true" keyProperty="flowId">
        insert into flow
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="flowName != null">flow_name,</if>
            <if test="sort != null">sort,</if>
            <if test="status != null">status,</if>
            <if test="delFlag != null">del_flag,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="flowName != null">#{flowName},</if>
            <if test="sort != null">#{sort},</if>
            <if test="status != null">#{status},</if>
            <if test="delFlag != null">#{delFlag},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
         </trim>
    </insert>

    <update id="updateFlow" parameterType="Flow">
        update flow
        <trim prefix="SET" suffixOverrides=",">
            <if test="flowName != null">flow_name = #{flowName},</if>
            <if test="sort != null">sort = #{sort},</if>
            <if test="status != null">status = #{status},</if>
            <if test="delFlag != null">del_flag = #{delFlag},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where flow_id = #{flowId}
    </update>

    <delete id="deleteFlowByFlowId" parameterType="Long">
        delete from flow where flow_id = #{flowId}
    </delete>

    <delete id="deleteFlowByFlowIds" parameterType="String">
        delete from flow where flow_id in 
        <foreach item="flowId" collection="array" open="(" separator="," close=")">
            #{flowId}
        </foreach>
    </delete>
</mapper>